#! /bin/sh

CONF=/mnt/mtd/ipc/conf
. $CONF/wifi.conf

NETDEV="ra0"
GATEWAY="192.168.1.1"

loadwifi()
{
iwpriv ra0 set AuthMode=$WifiMode
iwpriv ra0 set NetworkType=$WifiType
iwpriv ra0 set EncrypType=$WifiEnc
if [ $WifiEnc != "NONE" ]
then	
	if [ $WifiEnc == "WEP" ]
	then
		iwpriv ra0 set DefaultKeyID=1
		iwpriv ra0 set Key1="$WifiKey"
	else
		iwpriv ra0 set WPAPSK="$WifiKey"
	fi
fi
iwpriv ra0 set SSID="$WifiSsid"
}

loadNetwork()
{
	NETINFO=$CONF/config_net.ini
	NETPRIV=$CONF/config_priv.ini		

	killall udhcpc
	sleep 2
	killall udhcpc
    	
    dhcp1=`grep dhcp $NETINFO | awk -F "\"" '{print $2}'`
    ipaddr1=`grep ipaddr $NETINFO | awk -F "\"" '{print $2}'`
    gateway1=`grep gateway $NETINFO | awk -F "\"" '{print $2}'`
    netmask1=`grep netmask $NETINFO | awk -F "\"" '{print $2}'` 

    gat1=`echo $ipaddr1 | awk -F "." '{print $1}'`
    gat2=`echo $ipaddr1 | awk -F "." '{print $2}'`
    gat3=`echo $ipaddr1 | awk -F "." '{print $3}'`
    gat4=`echo $ipaddr1 | awk -F "." '{print $4}'`
    gateway2="$gat1.$gat2.$gat3.1"    
		
	if [ $dhcp1 = "y" ] 
	then
		$TARGET/dhcp.sh $NETDEV
		return 0
	fi   

	if ! ifconfig $NETDEV $ipaddr1 netmask $netmask1
	then
		ifconfig $NETDEV $DEF_IPADDR netmask 255.255.255.0	
	fi
	
	if ! route add default gw $gateway1
	then
		if ! route add default gw $gateway2
		then
			route add default gw $DEF_GATEWAY
		fi
	fi
		
	return 0      
}

sleep 60

while [ 1 ]
do
	sleep 60
    if ! iwconfig ra0 | grep "Access Point:" > /dev/null
    then
    	GATEWAY=`route | grep default | awk '{print $2}'`
		ifconfig ra0 down
		sleep 2
		ifconfig ra0 up
		loadwifi
		route add default gw $GATEWAY
    fi
done
