#! /bin/sh

MSG="/mnt/mtd/ipc/tmpfs/wps.tmp"
FLAG="/mnt/mtd/ipc/tmpfs/wps.dat"
WIFIPATH="/mnt/mtd/ipc/conf/wifi.conf"

killall updatewifi.sh
ifconfig ra0 down
sleep 1
ifconfig ra0 up
sleep 1
iwpriv ra0 wsc_conf_mode 1
iwpriv ra0 wsc_mode 2
iwpriv ra0 wsc_ap_band 0
iwpriv ra0 wsc_start
sleep 15
for i in $(seq 8)
do
	sleep 6
	iwpriv ra0 stat > $MSG
	if grep successfully $MSG
	then
		break
	fi
done

if [ $i -eq 8 ]
then	
	echo "error" > $FLAG
	ifconfig ra0 down
	exit 1
fi

iwpriv ra0 wsc_stop

SSID=`grep SSID $MSG | awk -F "= " '{print $2}'`
AuthType=`grep AuthType $MSG | awk -F "= " '{print $2}'`
EncrypType=`grep EncrypType $MSG | awk -F "= " '{print $2}'`
Key=`grep Key $MSG | awk -F "= " '{print $2}' | sed -n 2p`

echo $SSID
echo $AuthType
echo $EncrypType
echo $Key

echo "WifiEnable=1" > $WIFIPATH
echo "WifiType=Infra" >> $WIFIPATH
echo "WifiSsid=\"$SSID\"" >> $WIFIPATH
echo "WifiMode=$AuthType" >> $WIFIPATH
echo "WifiEnc=$EncrypType" >> $WIFIPATH
echo "WifiKey=\"$Key\"" >> $WIFIPATH 
sync

echo "good" > $FLAG

ifconfig ra0 down

exit 0
